# Nylas CLI Monorepo
This is a monorepo that contains the code for the Nylas CLI, the lambdas required for the websocket tunnel CLI command and the CLI's landing page website.

## The CLI
Read the [README](./cli/README.md) in the `cli/` folder.

## The Lambdas
Read the [README](./lambda/README.md) in the `lambda/` folder.

## The Website
Read the [README](./website/README.md) in the `website/` folder.

# Contribute
This repository follows the [gitflow workflow](https://www.atlassian.com/git/tutorials/comparing-workflows/gitflow-workflow) for new contributions and releases. 

## Branches
- The `develop` branch deploys (website, lambdas) to staging.
- The `main` branch deploys (website, lambdas) to production.
- Creating new version tags with the format `v#.#.#` creates a new Nylas CLI (binaries) release.

## New feature/bug-fix/chore
1. Create a new branch (feature, bug, chore) from the `develop` branch.
2. Create a PR for your new branch and set the base branch to the `develop` branch.
3. Squash and merge into the `develop` branch.
   - Note: The rest of the process is automated. A github action will automatically deploy changes to the website and the lambdas in `staging`.

## New hot-fix
1. Create a new branch (hot-fix) from the `main` branch.
2. Create a PR for your new branch and set the base branch to `main`.
3. Squash and merge into the `main` branch.
4. Merge the same commit into the `develop` branch.

## New releases (website, lambdas)
1. Create a new `release/v*` branch from `develop`. The `*` refers to an incremental version changes to the entire monorepo - not the Nylas CLI itself.
2. Create a PR for your new release branch and set the base branch to `main`.
3. Squash and merge the new release branch into `main`.
   - Note: The rest of the process is automated. A github action will automatically deploy changes to the website and the lambdas in `production`.

## New releases (nylas-cli binaries)
1. Create a new release tag from the `main` branch and label it `v*`. The `*` refers to the incremental version change for the Nylas CLI binaries (not the mono-repo)
   - Note: The rest of the process is automated. A github action will automatically generate the binaries for the CLI, update your release with release notes and update the Homebrew formula.